/*
 * generated by Xtext 2.32.0
 */
package no.ntnu.tdt4250.componentsdsl.serializer;

import com.google.inject.Inject;
import java.util.Set;
import no.ntnu.tdt4250.componentsdsl.componentsDSL.Component;
import no.ntnu.tdt4250.componentsdsl.componentsDSL.ComponentsDSLPackage;
import no.ntnu.tdt4250.componentsdsl.componentsDSL.Port;
import no.ntnu.tdt4250.componentsdsl.services.ComponentsDSLGrammarAccess;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.xtext.Action;
import org.eclipse.xtext.Parameter;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.serializer.ISerializationContext;
import org.eclipse.xtext.serializer.acceptor.SequenceFeeder;
import org.eclipse.xtext.serializer.sequencer.AbstractDelegatingSemanticSequencer;
import org.eclipse.xtext.serializer.sequencer.ITransientValueService.ValueTransient;

@SuppressWarnings("all")
public class ComponentsDSLSemanticSequencer extends AbstractDelegatingSemanticSequencer {

	@Inject
	private ComponentsDSLGrammarAccess grammarAccess;
	
	@Override
	public void sequence(ISerializationContext context, EObject semanticObject) {
		EPackage epackage = semanticObject.eClass().getEPackage();
		ParserRule rule = context.getParserRule();
		Action action = context.getAssignedAction();
		Set<Parameter> parameters = context.getEnabledBooleanParameters();
		if (epackage == ComponentsDSLPackage.eINSTANCE)
			switch (semanticObject.eClass().getClassifierID()) {
			case ComponentsDSLPackage.COMPONENT:
				sequence_Component(context, (Component) semanticObject); 
				return; 
			case ComponentsDSLPackage.PORT:
				sequence_Port(context, (Port) semanticObject); 
				return; 
			case ComponentsDSLPackage.SYSTEM:
				sequence_System(context, (no.ntnu.tdt4250.componentsdsl.componentsDSL.System) semanticObject); 
				return; 
			}
		if (errorAcceptor != null)
			errorAcceptor.accept(diagnosticProvider.createInvalidContextOrTypeDiagnostic(semanticObject, context));
	}
	
	/**
	 * <pre>
	 * Contexts:
	 *     Component returns Component
	 *
	 * Constraint:
	 *     (name=ID ports+=Port+)
	 * </pre>
	 */
	protected void sequence_Component(ISerializationContext context, Component semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     Port returns Port
	 *
	 * Constraint:
	 *     (name=ID provided?='provided' required?='required')
	 * </pre>
	 */
	protected void sequence_Port(ISerializationContext context, Port semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, ComponentsDSLPackage.Literals.PORT__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ComponentsDSLPackage.Literals.PORT__NAME));
			if (transientValues.isValueTransient(semanticObject, ComponentsDSLPackage.Literals.PORT__PROVIDED) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ComponentsDSLPackage.Literals.PORT__PROVIDED));
			if (transientValues.isValueTransient(semanticObject, ComponentsDSLPackage.Literals.PORT__REQUIRED) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ComponentsDSLPackage.Literals.PORT__REQUIRED));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getPortAccess().getNameIDTerminalRuleCall_0_0(), semanticObject.getName());
		feeder.accept(grammarAccess.getPortAccess().getProvidedProvidedKeyword_1_0(), semanticObject.isProvided());
		feeder.accept(grammarAccess.getPortAccess().getRequiredRequiredKeyword_2_0(), semanticObject.isRequired());
		feeder.finish();
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     System returns System
	 *
	 * Constraint:
	 *     components+=Component+
	 * </pre>
	 */
	protected void sequence_System(ISerializationContext context, no.ntnu.tdt4250.componentsdsl.componentsDSL.System semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
}
